SystemOrganization addCategory: #MetaInterpreter!

Object subclass: #ImplicitMetaObject
	instanceVariableNames: 'sendCallback readCallback writeCallback argCallback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaInterpreter'!

!ImplicitMetaObject methodsFor: 'accessing' stamp: 'NickPapoulias 5/7/2013 11:48'!
argCallback
	^ argCallback! !

!ImplicitMetaObject methodsFor: 'accessing' stamp: 'NickPapoulias 5/7/2013 11:48'!
argCallback: anObject
	argCallback := anObject! !

!ImplicitMetaObject methodsFor: 'accessing' stamp: 'NickPapoulias 5/7/2013 11:48'!
readCallback
	^ readCallback! !

!ImplicitMetaObject methodsFor: 'accessing' stamp: 'NickPapoulias 5/7/2013 11:48'!
readCallback: anObject
	readCallback := anObject! !

!ImplicitMetaObject methodsFor: 'accessing' stamp: 'NickPapoulias 5/7/2013 11:48'!
sendCallback
	^ sendCallback! !

!ImplicitMetaObject methodsFor: 'accessing' stamp: 'NickPapoulias 5/7/2013 11:48'!
sendCallback: anObject
	sendCallback := anObject! !

!ImplicitMetaObject methodsFor: 'accessing' stamp: 'NickPapoulias 5/7/2013 11:48'!
writeCallback
	^ writeCallback! !

!ImplicitMetaObject methodsFor: 'accessing' stamp: 'NickPapoulias 5/7/2013 11:48'!
writeCallback: anObject
	writeCallback := anObject! !

Object subclass: #MetaInterpreter
	instanceVariableNames: ''
	classVariableNames: 'BaseMetaDict'
	poolDictionaries: ''
	category: 'MetaInterpreter'!

!MetaInterpreter class methodsFor: 'initialiazation' stamp: 'NickPapoulias 5/7/2013 11:52'!
initialize

	super initialize.
	BaseMetaDict := Dictionary new.
	Smalltalk specialObjectsArray becomeForward: self newSpecialObjectsArray.! !

!MetaInterpreter class methodsFor: 'initialiazation' stamp: 'NickPapoulias 5/7/2013 12:42'!
newSpecialObjectsArray
	"Smalltalk recreateSpecialObjectsArray"
	
	"To external package developers:
	**** DO NOT OVERRIDE THIS METHOD.  *****
	If you are writing a plugin and need additional special object(s) for your own use, 
	use addGCRoot() function and use own, separate special objects registry "
	
	"The Special Objects Array is an array of objects used by the Squeak virtual machine.
	 Its contents are critical and accesses to it by the VM are unchecked, so don't even
	 think of playing here unless you know what you are doing."
	
	| newArray |
	newArray := Array new: 65.
	"Nil false and true get used throughout the interpreter"
	newArray at: 1 put: nil.
	newArray at: 2 put: false.
	newArray at: 3 put: true.
	"This association holds the active process (a ProcessScheduler)"
	newArray at: 4 put: (Smalltalk globals associationAt: #Processor).
	"Numerous classes below used for type checking and instantiation"
	newArray at: 5 put: Bitmap.
	newArray at: 6 put: SmallInteger.
	newArray at: 7 put: ByteString.
	newArray at: 8 put: Array.
	newArray at: 9 put: Smalltalk.
	newArray at: 10 put: Float.
	newArray at: 11 put: MethodContext.
	newArray at: 12 put: nil. "Was BlockContext"
	newArray at: 13 put: Point.
	newArray at: 14 put: LargePositiveInteger.
	newArray at: 15 put: Display.
	newArray at: 16 put: Message.
	newArray at: 17 put: CompiledMethod.
	newArray at: 18 put: (Smalltalk specialObjectsArray at: 18).
	"(low space Semaphore)"
	newArray at: 19 put: Semaphore.
	newArray at: 20 put: Character.
	newArray at: 21 put: #doesNotUnderstand:.
	newArray at: 22 put: #cannotReturn:.
	newArray at: 23 put: nil. "This is the process signalling low space."
	"An array of the 32 selectors that are compiled as special bytecodes,
	 paired alternately with the number of arguments each takes."
	newArray at: 24 put: #(	#+ 1 #- 1 #< 1 #> 1 #<= 1 #>= 1 #= 1 #~= 1
							#* 1 #/ 1 #\\ 1 #@ 1 #bitShift: 1 #// 1 #bitAnd: 1 #bitOr: 1
							#at: 1 #at:put: 2 #size 0 #next 0 #nextPut: 1 #atEnd 0 #== 1 nil 0
							nil 1 #value 0 #value: 1 #do: 1 #new 0 #new: 1 #x 0 #y 0 ).
	"An array of the 255 Characters in ascii order.
	 Cog inlines table into machine code at: prim so do not regenerate it."
	newArray at: 25 put: (Smalltalk specialObjectsArray at: 25).
	newArray at: 26 put: #mustBeBoolean.
	newArray at: 27 put: ByteArray.
	newArray at: 28 put: Process.
	"An array of up to 31 classes whose instances will have compact headers"
	newArray at: 29 put: Smalltalk compactClassesArray.
	newArray at: 30 put: (Smalltalk specialObjectsArray at: 30).
	"(delay Semaphore)"
	newArray at: 31 put: (Smalltalk specialObjectsArray at: 31).
	"(user interrupt Semaphore)"
	"Prototype instances that can be copied for fast initialization"
	newArray at: 32 put: (Float new: 2).
	newArray at: 33 put: (LargePositiveInteger new: 4).
	newArray at: 34 put: 0@0.
	newArray at: 35 put: #cannotInterpret:.
	"Note: This must be fixed once we start using context prototypes (yeah, right)"
	"(MethodContext new: CompiledMethod fullFrameSize)."
	newArray at: 36 put: (Smalltalk specialObjectsArray at: 36). "Is the prototype MethodContext (unused by the VM)"
	newArray at: 37 put: BlockClosure.
	"(BlockContext new: CompiledMethod fullFrameSize)."
	newArray at: 38 put: (Smalltalk specialObjectsArray at: 38). "Is the prototype BlockContext (unused by the VM)"
	"array of objects referred to by external code"
	newArray at: 39 put: (Smalltalk specialObjectsArray at: 39).	"preserve external semaphores"
	newArray at: 40 put: nil. "Reserved for Mutex in Cog VMs"
	newArray at: 41 put: nil. "Reserved for a LinkedList instance for overlapped calls in CogMT"
	"finalization Semaphore"
	newArray at: 42 put: ((Smalltalk specialObjectsArray at: 42) ifNil: [Semaphore new]).
	newArray at: 43 put: LargeNegativeInteger.
	"External objects for callout.
	 Note: Written so that one can actually completely remove the FFI."
	newArray at: 44 put: (Smalltalk at: #ExternalAddress ifAbsent: []).
	newArray at: 45 put: (Smalltalk at: #ExternalStructure ifAbsent: []).
	newArray at: 46 put: (Smalltalk at: #ExternalData ifAbsent: []).
	newArray at: 47 put: (Smalltalk at: #ExternalFunction ifAbsent: []).
	newArray at: 48 put: (Smalltalk at: #ExternalLibrary ifAbsent: []).
	newArray at: 49 put: #aboutToReturn:through:.
	newArray at: 50 put: #run:with:in:.
	"51 reserved for immutability message"
	"newArray at: 51 put: #attemptToAssign:withIndex:."
	newArray at: 52 put: #(nil "nil => generic error" #'bad receiver'
							#'bad argument' #'bad index'
							#'bad number of arguments'
							#'inappropriate operation'  #'unsupported operation'
							#'no modification' #'insufficient object memory'
							#'insufficient C memory' #'not found' #'bad method'
							#'internal error in named primitive machinery'
							#'object may move').
	"53 to 55 are for Alien"
	newArray at: 53 put: (Smalltalk at: #Alien ifAbsent: []).
	newArray at: 54 put: #invokeCallback:stack:registers:jmpbuf:.
	newArray at: 55 put: (Smalltalk at: #UnsafeAlien ifAbsent: []).

	"Weak reference finalization"
	newArray at: 56 put: (Smalltalk at: #WeakFinalizationList ifAbsent: []).
	newArray at: 59 put: #metaReceived:.
	newArray at: 60 put: #metaRef.
	newArray at: 61 put: #metaReadAt:.
	newArray at: 62 put: #metaWriteAt:Put:.
	newArray at: 63 put: #metaArgIn:for:.
	newArray at: 64 put: MetaInterpreter.
	newArray at: 65 put: #metaSend:from:.
	^newArray! !

!MetaInterpreter class methodsFor: 'introspection' stamp: 'NickPapoulias 5/5/2013 18:43'!
object: anObject at: anIndex

	<primitive: 73>
	! !

!MetaInterpreter class methodsFor: 'modification' stamp: 'NickPapoulias 5/5/2013 18:43'!
object: anObject at: anIndex put: anotherObject

	<primitive: 74>
	! !

!MetaInterpreter class methodsFor: 'intercession' stamp: 'NickPapoulias 5/7/2013 14:09'!
object: anObject metaArgIn: aMessage withReceiver: rcvr

	| offendingContext triggerObject method sender receiverOrNil messageOrNil |
	Transcript show: thisContext; cr.
	
	triggerObject := anObject.
	offendingContext := thisContext sender sender.
	method := offendingContext method.
	sender := offendingContext receiver.
	receiverOrNil := rcvr.
	messageOrNil := aMessage.

	anObject experimentalBit: true.

	^ self object: rcvr perform: aMessage selector withArguments: aMessage arguments.! !

!MetaInterpreter class methodsFor: 'intercession' stamp: 'NickPapoulias 5/7/2013 13:30'!
object: anObject metaReadAt: anIndex

	| offendingContext |
	Transcript show: thisContext; cr.
	
	offendingContext := thisContext sender sender.
	
	self halt.

	anObject experimentalBit: true.

	^ self object: anObject at: anIndex! !

!MetaInterpreter class methodsFor: 'intercession' stamp: 'NickPapoulias 5/7/2013 13:30'!
object: anObject metaReceived: aMessage

	| offendingContext |
	Transcript show: thisContext; cr.
	
	offendingContext := thisContext sender sender.
	
	self halt.

	anObject experimentalBit: true.

	^ self object: anObject perform: aMessage selector withArguments: aMessage arguments.! !

!MetaInterpreter class methodsFor: 'intercession' stamp: 'NickPapoulias 5/7/2013 13:30'!
object: anObject metaSend: aMessage withReceiver: anotherObject

	| offendingContext |
	Transcript show: thisContext; cr.
	
	offendingContext := thisContext sender sender.
	
	self halt.
	
	anObject experimentalBit: true.
	
	^ self object: anotherObject perform: aMessage selector withArguments: aMessage arguments.! !

!MetaInterpreter class methodsFor: 'intercession' stamp: 'NickPapoulias 5/7/2013 13:30'!
object: anObject metaWriteAt: anIndex Put: anotherObject

	| offendingContext |
	Transcript show: thisContext; cr.
	
	offendingContext := thisContext sender sender.
	
	self halt.

	anObject experimentalBit: true.

	^ self object: anObject at: anIndex put: anotherObject ! !

!MetaInterpreter class methodsFor: 'execution' stamp: 'NickPapoulias 5/5/2013 18:44'!
object: anObject perform: aSelector withArguments: args 

	<primitive: 84>! !

!MetaInterpreter class methodsFor: 'intercession' stamp: 'NickPapoulias 5/7/2013 12:21'!
objectMetaRef: anObject

	self halt.

	Transcript show: thisContext; cr.
	
	anObject experimentalBit: true.
	
	^ anObject! !

!MetaInterpreter class methodsFor: 'binding' stamp: 'NickPapoulias 5/7/2013 12:07'!
onArgumentForObject: anObject do: aCallback! !

!MetaInterpreter class methodsFor: 'binding' stamp: 'NickPapoulias 5/7/2013 11:55'!
onIvReadForObject: anObject do: aCallback! !

!MetaInterpreter class methodsFor: 'binding' stamp: 'NickPapoulias 5/7/2013 11:56'!
onIvWriteForObject: anObject do: aCallback! !

!MetaInterpreter class methodsFor: 'binding' stamp: 'NickPapoulias 5/7/2013 12:14'!
onMessageReceivedForObject: anObject do: aCallback! !

!MetaInterpreter class methodsFor: 'binding' stamp: 'NickPapoulias 5/7/2013 12:14'!
onMessageSendFromObject: anObject do: aCallback! !

!Object methodsFor: '*MetaInterpreter' stamp: 'NickPapoulias 5/5/2013 18:49'!
experimentalBit
	^ self primitiveGetExperimentalBit ! !

!Object methodsFor: '*MetaInterpreter' stamp: 'NickPapoulias 5/5/2013 18:49'!
experimentalBit: aBoolean
	self primitiveSetExperimentalBitTo: aBoolean! !

!Object methodsFor: '*MetaInterpreter' stamp: 'NickPapoulias 5/5/2013 18:49'!
isExperimentalBitOn
	^ self experimentalBit! !

!Object methodsFor: '*MetaInterpreter' stamp: 'NickPapoulias 5/7/2013 11:31'!
metaArgIn: aMessage for: anObject

	^ MetaInterpreter object: anObject metaArgIn: aMessage withReceiver: self! !

!Object methodsFor: '*MetaInterpreter' stamp: 'NickPapoulias 5/5/2013 18:41'!
metaReadAt: anIndex

	^ MetaInterpreter object: self metaReadAt: anIndex! !

!Object methodsFor: '*MetaInterpreter' stamp: 'NickPapoulias 5/7/2013 12:19'!
metaReceived: aMessage

	^ MetaInterpreter object: self metaReceived: aMessage ! !

!Object methodsFor: '*MetaInterpreter' stamp: 'NickPapoulias 5/5/2013 18:39'!
metaRef

	self halt! !

!Object methodsFor: '*MetaInterpreter' stamp: 'NickPapoulias 5/7/2013 12:41'!
metaSend: aMessage from: anObject

	^ MetaInterpreter object: anObject metaSend: aMessage withReceiver: self.! !

!Object methodsFor: '*MetaInterpreter' stamp: 'NickPapoulias 5/5/2013 18:41'!
metaWriteAt: anIndex Put: anotherObject

	^ MetaInterpreter object: self metaWriteAt: anIndex Put: anotherObject! !

!Object methodsFor: '*MetaInterpreter' stamp: 'NickPapoulias 5/5/2013 18:50'!
primitiveGetExperimentalBit

	<primitive: 150>
	self primitiveFailed! !

!Object methodsFor: '*MetaInterpreter' stamp: 'NickPapoulias 5/5/2013 18:50'!
primitiveSetExperimentalBitTo: aBoolean

	<primitive: 151>
	self primitiveFailed! !

Object subclass: #Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaInterpreter'!

!Test methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/5/2013 19:03'!
sendObjectAsArgument: anObject

	Transcript show: anObject class.
	Transcript show: 'say what ?'.! !

!Test methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/5/2013 19:03'!
sendObjectAsArgument: anObject withOtherArgs: anotherObject

	Transcript show: anObject class.
	Transcript show: 'say what ?'.! !

!Test methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/5/2013 19:03'!
test

	|object|
	
	object := TestObject new.
	object experimentalBit: true.
	object test.
	self sendObjectAsArgument: object withOtherArgs: 3.! !

Object subclass: #TestObject
	instanceVariableNames: 'x z'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaInterpreter'!

!TestObject methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/5/2013 19:02'!
test

	|y|
	
	self experimentalBit: true.

	x := self class.
	Transcript show: x.
	Transcript show: 'wtf'.
	Transcript show: (self instVarNamed: #x).
	Transcript show: 'what'; cr.
	Transcript show: x.! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/5/2013 19:02'!
test2

	self experimentalBit: true.

	self x: 3.! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/7/2013 13:02'!
test3

	self experimentalBit: true.

	Transcript show: 'got it ?'! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/5/2013 19:02'!
x

	^ x! !

!TestObject methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/5/2013 19:02'!
x: anObject 

	x := anObject ! !
MetaInterpreter initialize!
